clear all;clc;close all %#ok<CLALL>
[~,txt,~] = xlsread('MM summ_may_2017_3.xlsx',2,'A1:CJ166');
%% baseline
for a=2:5:162
    for b=4:1:26
        c=b-3;
        d=(((a-2)/5))*23;
        if ~isequal(txt(a,b),{''})
            base(c+d) = txt(a+4,b);
        end
    end
end
idx=cellfun(@(x) isequal(x,''),base);base(idx)=[];
%% first run
for a=3:5:163
    for b=4:1:26
        c=b-3;
        d=(((a-3)/5))*23;
        if ~(b==8 && a==58) && ~isequal(txt(a,b),{''}) %exception for ppt 12 who discarded "Clutch" after baseline run
            fst(c+d) = txt(a+3,b);
        end
    end
end
idx1=cellfun(@(x) isequal(x,''),fst);fst(idx1)=[];
%% second run
for a=4:5:164
    for b=4:1:26
        c=b-3;
        d=(((a-4)/5))*23;
        if ~(b==8 && a==59) && ~(b==8 && a==79) && ~isequal(txt(a,b),{''})  %exception for ppt 12 who discarded "Clutch" after baseline run, %exception for ppt 16 who discarded "Prime Operator Human 2" after 1st run
            snd(c+d) = txt(a+2,b);
        end
    end
end
idx1=cellfun(@(x) isequal(x,''),snd);snd(idx1)=[];
%% third run
for a=5:5:165
    for b=4:1:26
        c=b-3;
        d=(((a-5)/5))*23;
        if ~(b==8 && a==60) && ~(b==8 && a==80) && ~(b==10 && a==55) && ~(b==12 && a==55) && ~(b==5 && a==165) && ~isequal(txt(a,b),{''})
            %exception for ppt 12 who discarded "Clutch" after baseline run
            %exception for ppt 16 who discarded "Prime Operator Human 2" after 1st run
            %exception for ppt 10 who discarded "Safety Override" after 2nd run
            %exception for ppt 10 who discarded "Human" after 2nd run
            %exception for ppt 33 who discarded "Road Holding" after 2nd run
            trd(c+d) = txt(a+1,b);
        end
    end
end
idx1=cellfun(@(x) isequal(x,''),trd);trd(idx1)=[];
%% determine number of concepts per participant
lenB = sum(~strcmp(txt(2:5:162,4:26),''),2)';
len1 = sum(~strcmp(txt(3:5:163,4:26),''),2)';
len2 = sum(~strcmp(txt(4:5:164,4:26),''),2)';
len3 = sum(~strcmp(txt(5:5:165,4:26),''),2)';
%% initialize a few variables
eB=0;e1=0;e2=0;e3=0;

%% baseline
fromB=zeros(1,378);toB=zeros(1,378);
for a=2:5:162
    g=((a-2)/5);
    plusB = sum(lenB(1:g));
    for b=27:1:73
        eB=b-26;f=(((a-2)/5))*47;
        temp=cell2mat(txt(a,b));
        if ~isempty(temp)
            fromB(eB+f) = str2double(temp(1:strfind(temp,'-')-1))+plusB;
            toB(eB+f) = str2double(temp(strfind(temp,'-')+1:end))+plusB;
        end
    end
end
fromB(fromB==0)=[];toB(toB==0)=[];
%% first run
from1=zeros(1,442);to1=zeros(1,442);
for a=3:5:163
    g=((a-3)/5);
    plus1 = sum(len1(1:g));
    for b=27:1:73
        e1=b-26;f=(((a-3)/5))*47;
        temp=cell2mat(txt(a,b));
        if ~isempty(temp)
            from1(e1+f) = str2double(temp(1:strfind(temp,'-')-1))+plus1;
            to1(e1+f) = str2double(temp(strfind(temp,'-')+1:end))+plus1;
        end
    end
end
from1(from1==0)=[];to1(to1==0)=[];
%% second run
from2=zeros(1,534);to2=zeros(1,534);
for a=4:5:164
    g=((a-4)/5);
    plus2 = sum(len2(1:g));
    for b=27:1:73
        e2=b-26;f=(((a-4)/5))*47;
        temp=cell2mat(txt(a,b));
        if ~isempty(temp)
            from2(e2+f) = str2double(temp(1:strfind(temp,'-')-1))+plus2;
            to2(e2+f) = str2double(temp(strfind(temp,'-')+1:end))+plus2;
        end
    end
end
from2(from2==0)=[];to2(to2==0)=[];
%% third run
from3=zeros(1,572);to3=zeros(1,572);
for a=5:5:165
    g=((a-5)/5);
    plus3 = sum(len3(1:g));
    for b=27:1:73
        e3=b-26;f=(((a-5)/5))*47;
        temp=cell2mat(txt(a,b));
        if ~isempty(temp)
            from3(e3+f) = str2double(temp(1:strfind(temp,'-')-1))+plus3;
            to3(e3+f) = str2double(temp(strfind(temp,'-')+1:end))+plus3;
        end
    end
end
from3(from3==0)=[];to3(to3==0)=[];
%% labeling and matricizing
fromB_label=base(fromB); toB_label=base(toB);
from1_label=fst(from1);  to1_label=fst(to1);
from2_label=snd(from2);  to2_label=snd(to2);
from3_label=trd(from3);  to3_label=trd(to3);
sorted_label = {'1. Information Acquisition'    '2. Information Analysis'    '3. Decision Selection'    '4. Action Implementation'    '5. Other'};
matrixB=zeros(5,5);matrix1=zeros(5,5);matrix2=zeros(5,5);matrix3=zeros(5,5);
matrixBperc=NaN(5,5);matrix1perc=NaN(5,5);matrix2perc=NaN(5,5);matrix3perc=NaN(5,5);
%% fill matrices
%%baseline
for a=1:5
    for b=1:5
        for c=1:length(fromB_label)
            if isequal(fromB_label(c),sorted_label(a)) && isequal(toB_label(c),sorted_label(b))
                matrixB(a,b)=matrixB(a,b)+1;
            end
        end
    end
end
%%first run
for a=1:5
    for b=1:5
        for c=1:length(from1_label)
            if isequal(from1_label(c),sorted_label(a)) && isequal(to1_label(c),sorted_label(b))
                matrix1(a,b)=matrix1(a,b)+1;
            end
        end
    end
end
%%second run
for a=1:5
    for b=1:5
        for c=1:length(from2_label)
            if isequal(from2_label(c),sorted_label(a)) && isequal(to2_label(c),sorted_label(b))
                matrix2(a,b)=matrix2(a,b)+1;
            end
        end
    end
end
%%third run
for a=1:5
    for b=1:5
        for c=1:length(from3_label)
            if isequal(from3_label(c),sorted_label(a)) && isequal(to3_label(c),sorted_label(b))
                matrix3(a,b)=matrix3(a,b)+1;
            end
        end
    end
end
for a=1:5
    for b=1:5
        matrixBperc(a,b) = (matrixB(a,b)/(sum(sum(matrixB))))*100;
        matrix1perc(a,b) = (matrix1(a,b)/(sum(sum(matrix1))))*100;
        matrix2perc(a,b) = (matrix2(a,b)/(sum(sum(matrix2))))*100;
        matrix3perc(a,b) = (matrix3(a,b)/(sum(sum(matrix3))))*100;
    end
end

%%
figure;hold on
for i1=1:size(matrixB,1)
    for i2=1:size(matrixB,2)
        subplot(5,5,(i1-1)*5+i2);
        if i1<i2 && i1<5 && i2<5; %(i1==1 && i2==2) || (i1==2 && i2==3) || (i1==3 && i2==4)
            bar([matrixB(i1,i2) matrix1(i1,i2) matrix2(i1,i2) matrix3(i1,i2)],'facecolor','k')
        elseif i1>i2 && i1<5 && i2<5; %(i1==1 && i2==2) || (i1==2 && i2==3) || (i1==3 && i2==4)
            bar([matrixB(i1,i2) matrix1(i1,i2) matrix2(i1,i2) matrix3(i1,i2)],'facecolor',[1 1 1])
        else
            bar([matrixB(i1,i2) matrix1(i1,i2) matrix2(i1,i2) matrix3(i1,i2)],'facecolor',[.5 .5 .5])
        end
        set(gca,'ylim',[0 100],'xlim',[0.3 4.7],'xtick',1:4,'xticklabel',{'B' 'Run 1', 'Run 2', 'Run 3'},'ytick',0:20:100)
        set(gca,'ygrid','on')
    end
end
axes(gca) % sets ax1 to current axes
text(-27,50,'Other','Fontsize',16)

text(-27,205,'Action','Fontsize',16)
text(-27,180,'implementation','Fontsize',16)

text(-27,343,'Decision','Fontsize',16)
text(-27,318,'selection','Fontsize',16)

text(-27,480,'Information','Fontsize',16)
text(-27,455,'analysis','Fontsize',16)

text(-27,605,'Information','Fontsize',16)
text(-27,580,'acquisition','Fontsize',16)

%text(1.8,680,'Other','Fontsize',16)
text(-5,700,'Action','Fontsize',16)
text(-10,700,'Decision','Fontsize',16)
text(-15.8,700,'Information','Fontsize',16)
text(-21.8,700,'Information','Fontsize',16)
text(1.8,680,'Other','Fontsize',16)
text(-5,680,'implementation','Fontsize',16)
text(-10,680,'selection','Fontsize',16)
text(-15.8,680,'analysis','Fontsize',16)
text(-21.8,680,'acquisition','Fontsize',16)
text(-27,650,'From','fontsize',24,'fontweight','bold')
text(-23.5,700,'To','fontsize',24,'fontweight','bold')

[num,txt,raw] = xlsread('MM summ_may_2017_3.xlsx',1,'A3:U35');

concB=num(:,4);conc1=num(:,9);conc2=num(:,14);conc3=num(:,19); % number of concepts per run
linkB=num(:,5);link1=num(:,10);link2=num(:,15);link3=num(:,20); % number of links per run
m(1)=mean(concB);m(2)=mean(conc1);m(3)=mean(conc2);m(4)=mean(conc3);m(8)=mean(linkB);m(9)=mean(link1);m(10)=mean(link2);m(11)=mean(link3);
sd(1)=std(concB);sd(2)=std(conc1);sd(3)=std(conc2);sd(4)=std(conc3);sd(8)=std(linkB);sd(9)=std(link1);sd(10)=std(link2);sd(11)=std(link3);
concLTD=NaN(33,1);concMTD=NaN(33,1);concHTD=NaN(33,1);
linkLTD=NaN(33,1);linkMTD=NaN(33,1);linkHTD=NaN(33,1);

for i=1:length(txt)
    for j=6:5:16
        if strcmp(txt(i,j),'LW')
            concLTD(i)=num(i,j+3);
            linkLTD(i)=num(i,j+4);
        else if strcmp(txt(i,j),'MW')
            concMTD(i)=num(i,j+3);
            linkMTD(i)=num(i,j+4);
        else if strcmp(txt(i,j),'HW')
            concHTD(i)=num(i,j+3);
            linkHTD(i)=num(i,j+4);
            end
            end
        end
    end
end
m(5)=mean(concLTD);m(6)=mean(concMTD);m(7)=mean(concHTD);m(12)=mean(linkLTD);m(13)=mean(linkMTD);m(14)=mean(linkHTD);
sd(5)=std(concLTD);sd(6)=std(concMTD);sd(7)=std(concHTD);sd(12)=std(linkLTD);sd(13)=std(linkMTD);sd(14)=std(linkHTD);
disp('Concepts')
fprintf('\t\tBaseline  Run 1\t\tRun 2\t  Run 3\t\tLTD\t\t  MTD\t\tHTD\n')
fprintf('M\t') 
disp(m(1:7))
fprintf('SD\t')
disp(sd(1:7))

disp('Links')
fprintf('\t\tBaseline  Run 1\t\tRun 2\t  Run 3\t\tLTD\t\t  MTD\t\tHTD\n')
fprintf('M\t') 
disp(m(8:14))
fprintf('SD\t')
disp(sd(8:14))

% Concepts
[~,p1,~,stats1]=ttest(concB,conc1);
[~,p2,~,stats2]=ttest(concB,conc2);
[~,p3,~,stats3]=ttest(concB,conc3);
disp(['B vs. 1: dz = ' sprintf('%0.2f',stats1.tstat/sqrt(stats1.df+1)) ', p = ' sprintf('%0.3f',p1)])
disp(['B vs. 2: dz = ' sprintf('%0.2f',stats2.tstat/sqrt(stats2.df+1)) ', p = ' sprintf('%0.3f',p2)])
disp(['B vs. 3: dz = ' sprintf('%0.2f',stats3.tstat/sqrt(stats3.df+1)) ', p = ' sprintf('%0.3f',p3)])
[~,p4,~,stats4]=ttest(concB,concLTD);
[~,p5,~,stats5]=ttest(concB,concMTD);
[~,p6,~,stats6]=ttest(concB,concHTD);
disp(['B vs. LTD: dz = ' sprintf('%0.2f',stats4.tstat/sqrt(stats4.df+1)) ', p = ' sprintf('%0.3f',p4)])
disp(['B vs. MTD: dz = ' sprintf('%0.2f',stats5.tstat/sqrt(stats5.df+1)) ', p = ' sprintf('%0.3f',p5)])
disp(['B vs. HTD: dz = ' sprintf('%0.2f',stats6.tstat/sqrt(stats6.df+1)) ', p = ' sprintf('%0.3f',p6)])

[~,p7,~,stats7]=ttest(conc1,conc2);
[~,p8,~,stats8]=ttest(conc1,conc3);
[~,p9,~,stats9]=ttest(conc2,conc3);
disp(['1 vs. 2: dz = ' sprintf('%0.2f',stats7.tstat/sqrt(stats7.df+1)) ', p = ' sprintf('%0.3f',p7)])
disp(['1 vs. 3: dz = ' sprintf('%0.2f',stats8.tstat/sqrt(stats8.df+1)) ', p = ' sprintf('%0.3f',p8)])
disp(['2 vs. 3: dz = ' sprintf('%0.2f',stats9.tstat/sqrt(stats9.df+1)) ', p = ' sprintf('%0.3f',p9)])
[~,p10,~,stats10]=ttest(concLTD,concMTD);
[~,p11,~,stats11]=ttest(concLTD,concHTD);
[~,p12,~,stats12]=ttest(concMTD,concHTD);
disp(['LTD vs. MTD: dz = ' sprintf('%0.2f',stats10.tstat/sqrt(stats10.df+1)) ', p = ' sprintf('%0.3f',p10)])
disp(['LTD vs. HTD: dz = ' sprintf('%0.2f',stats11.tstat/sqrt(stats11.df+1)) ', p = ' sprintf('%0.3f',p11)])
disp(['MTD vs. HTD: dz = ' sprintf('%0.2f',stats12.tstat/sqrt(stats12.df+1)) ', p = ' sprintf('%0.3f',p12)])

% Links
[~,p13,~,stats13]=ttest(linkB,link1);
[~,p14,~,stats14]=ttest(linkB,link2);
[~,p15,~,stats15]=ttest(linkB,link3);
disp(['B vs. 1: dz = ' sprintf('%0.2f',stats13.tstat/sqrt(stats13.df+1)) ', p = ' sprintf('%0.3f',p13)])
disp(['B vs. 2: dz = ' sprintf('%0.2f',stats14.tstat/sqrt(stats14.df+1)) ', p = ' sprintf('%0.3f',p14)])
disp(['B vs. 3: dz = ' sprintf('%0.2f',stats15.tstat/sqrt(stats15.df+1)) ', p = ' sprintf('%0.3f',p15)])
[~,p16,~,stats16]=ttest(linkB,linkLTD);
[~,p17,~,stats17]=ttest(linkB,linkMTD);
[~,p18,~,stats18]=ttest(linkB,linkHTD);
disp(['B vs. LTD: dz = ' sprintf('%0.2f',stats16.tstat/sqrt(stats16.df+1)) ', p = ' sprintf('%0.3f',p16)])
disp(['B vs. MTD: dz = ' sprintf('%0.2f',stats17.tstat/sqrt(stats17.df+1)) ', p = ' sprintf('%0.3f',p17)])
disp(['B vs. HTD: dz = ' sprintf('%0.2f',stats18.tstat/sqrt(stats18.df+1)) ', p = ' sprintf('%0.3f',p18)])

[~,p19,~,stats19]=ttest(link1,link2);
[~,p20,~,stats20]=ttest(link1,link3);
[~,p21,~,stats21]=ttest(link2,link3);
disp(['1 vs. 2: dz = ' sprintf('%0.2f',stats19.tstat/sqrt(stats19.df+1)) ', p = ' sprintf('%0.3f',p19)])
disp(['1 vs. 3: dz = ' sprintf('%0.2f',stats20.tstat/sqrt(stats20.df+1)) ', p = ' sprintf('%0.3f',p20)])
disp(['2 vs. 3: dz = ' sprintf('%0.2f',stats21.tstat/sqrt(stats21.df+1)) ', p = ' sprintf('%0.3f',p21)])
[~,p22,~,stats22]=ttest(linkLTD',linkMTD');
[~,p23,~,stats23]=ttest(linkLTD',linkHTD');
[~,p24,~,stats24]=ttest(linkMTD',linkHTD');
disp(['LTD vs. MTD: dz = ' sprintf('%0.2f',stats22.tstat/sqrt(stats22.df+1)) ', p = ' sprintf('%0.3f',p22)])
disp(['LTD vs. HTD: dz = ' sprintf('%0.2f',stats23.tstat/sqrt(stats23.df+1)) ', p = ' sprintf('%0.3f',p23)])
disp(['MTD vs. HTD: dz = ' sprintf('%0.2f',stats24.tstat/sqrt(stats24.df+1)) ', p = ' sprintf('%0.3f',p24)])

corr([linkLTD+linkMTD+linkHTD+linkB],[concLTD+concMTD+concHTD+concB],'type','spearman')
